unit fUPDateEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, ExtCtrls, Calendar, uUPCalendar,
  uUPScrollbarButton;

type
  TfrmCalendarEdit = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    pnlDate: TPanel;
    Calendar: TUPCalendar;
    lblDate: TLabel;
    btnLeft: TUPScrollbarButton;
    btnRight: TUPScrollbarButton;
    procedure CalendarDblClick(Sender: TObject);
    procedure CalendarChange(Sender: TObject);
    procedure btnNextClick(Sender: TObject);
    procedure btnPreviousClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CalendarKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure UpdateDisplay;
    { Private declarations }
  public
    procedure CreateParams(var Params: TCreateParams); override;
    { Public declarations }
  end;

var
  frmCalendarEdit: TfrmCalendarEdit;

implementation

{$R *.DFM}

procedure TfrmCalendarEdit.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
 // Params.Style := Params.Style or WS_BORDER;
end;

procedure TfrmCalendarEdit.UpdateDisplay;
begin
  lblDate.Caption := FormatDateTime('dd mmmm yyyy', Calendar.CalendarDate);
end;

procedure TfrmCalendarEdit.CalendarDblClick(Sender: TObject);
begin
  ModalResult := mrOK;
  Close;
end;

procedure TfrmCalendarEdit.CalendarChange(Sender: TObject);
begin
  UpdateDisplay;
end;

procedure TfrmCalendarEdit.btnNextClick(Sender: TObject);
begin
  Calendar.NextMonth;
end;

procedure TfrmCalendarEdit.btnPreviousClick(Sender: TObject);
begin
  Calendar.PrevMonth;
end;

procedure TfrmCalendarEdit.FormCreate(Sender: TObject);
begin
  UpdateDisplay;
  ActiveControl := Calendar;
end;

procedure TfrmCalendarEdit.CalendarKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_RETURN   : begin
                    ModalResult := mrOK;
                    Close;
                  end;
    VK_ESCAPE   : begin
                    ModalResult := mrCancel;
                    Close;
                  end;
    VK_LEFT     : if ssShift in Shift
                  then begin
                         Calendar.PrevMonth;
                         Key := 0;
                       end
                  else if ssCtrl in Shift
                       then begin
                              Calendar.PrevYear;
                              Key := 0;
                            end;
    VK_RIGHT    : if ssShift in Shift
                  then begin
                         Calendar.NextMonth;
                         Key := 0;
                       end
                  else if ssCtrl in Shift
                       then begin
                              Calendar.NextYear;
                              Key := 0;
                            end;
  end;
end;

procedure TfrmCalendarEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

end.
